#ifndef mozilla_dom_BindingNames_h
#define mozilla_dom_BindingNames_h

#include <stddef.h>
#include <stdint.h>
#include "mozilla/Attributes.h"

namespace mozilla::dom {

enum class BindingNamesOffset : uint16_t {
  ANGLE_instanced_arrays = 0,
  APZHitResultFlags = 23,
  AbortController = 41,
  AbortSignal = 57,
  AbstractRange = 69,
  AccessibleNode = 83,
  Addon = 98,
  AddonEvent = 104,
  AddonInstall = 115,
  AddonManager = 128,
  AddonManagerPermissions = 141,
  AnalyserNode = 165,
  Animation = 178,
  AnimationEffect = 188,
  AnimationEvent = 204,
  AnimationPlaybackEvent = 219,
  AnimationTimeline = 242,
  AnonymousContent = 260,
  Attr = 277,
  Audio = 282,
  AudioBuffer = 288,
  AudioBufferSourceNode = 300,
  AudioContext = 322,
  AudioDestinationNode = 335,
  AudioListener = 356,
  AudioNode = 370,
  AudioParam = 380,
  AudioParamMap = 391,
  AudioProcessingEvent = 405,
  AudioScheduledSourceNode = 426,
  AudioTrack = 451,
  AudioTrackList = 462,
  AudioWorklet = 477,
  AudioWorkletGlobalScope = 490,
  AudioWorkletNode = 514,
  AudioWorkletProcessor = 531,
  AuthenticatorAssertionResponse = 553,
  AuthenticatorAttestationResponse = 584,
  AuthenticatorResponse = 617,
  BarProp = 639,
  BaseAudioContext = 647,
  BatteryManager = 664,
  BeforeUnloadEvent = 679,
  BiquadFilterNode = 697,
  Blob = 714,
  BlobEvent = 719,
  BroadcastChannel = 729,
  BrowsingContext = 746,
  BrowsingContextGroup = 762,
  ByteLengthQueuingStrategy = 783,
  CDATASection = 809,
  CSS = 822,
  CSS2Properties = 826,
  CSSAnimation = 841,
  CSSConditionRule = 854,
  CSSContainerRule = 871,
  CSSCounterStyleRule = 888,
  CSSFontFaceRule = 908,
  CSSFontFeatureValuesRule = 924,
  CSSFontPaletteValuesRule = 949,
  CSSGroupingRule = 974,
  CSSImportRule = 990,
  CSSKeyframeRule = 1004,
  CSSKeyframesRule = 1020,
  CSSLayerBlockRule = 1037,
  CSSLayerStatementRule = 1055,
  CSSMediaRule = 1077,
  CSSMozDocumentRule = 1090,
  CSSNamespaceRule = 1109,
  CSSPageRule = 1126,
  CSSPseudoElement = 1138,
  CSSRule = 1155,
  CSSRuleList = 1163,
  CSSStyleDeclaration = 1175,
  CSSStyleRule = 1195,
  CSSStyleSheet = 1208,
  CSSSupportsRule = 1222,
  CSSTransition = 1238,
  Cache = 1252,
  CacheStorage = 1258,
  CallbackDebuggerNotification = 1271,
  CanonicalBrowsingContext = 1300,
  CanvasCaptureMediaStream = 1325,
  CanvasGradient = 1350,
  CanvasPattern = 1365,
  CanvasRenderingContext2D = 1379,
  CaretPosition = 1404,
  CaretStateChangedEvent = 1418,
  ChannelMergerNode = 1441,
  ChannelSplitterNode = 1459,
  ChannelWrapper = 1479,
  CharacterData = 1494,
  CheckerboardReportService = 1508,
  ChildProcessMessageManager = 1534,
  ChildSHistory = 1561,
  ChromeMessageBroadcaster = 1575,
  ChromeMessageSender = 1600,
  ChromeNodeList = 1620,
  ChromeUtils = 1635,
  ChromeWorker = 1647,
  Client = 1660,
  Clients = 1667,
  Clipboard = 1675,
  ClipboardEvent = 1685,
  ClipboardItem = 1700,
  ClonedErrorHolder = 1714,
  CloseEvent = 1732,
  CommandEvent = 1743,
  Comment = 1756,
  CompositionEvent = 1764,
  ConsoleInstance = 1781,
  ConstantSourceNode = 1797,
  ContentFrameMessageManager = 1816,
  ContentProcessMessageManager = 1843,
  ConvolverNode = 1872,
  CountQueuingStrategy = 1886,
  CreateOfferRequest = 1907,
  Credential = 1926,
  CredentialsContainer = 1937,
  Crypto = 1958,
  CryptoKey = 1965,
  CustomElementRegistry = 1975,
  CustomEvent = 1997,
  DOMException = 2009,
  DOMImplementation = 2022,
  DOMLocalization = 2040,
  DOMMatrix = 2056,
  DOMMatrixReadOnly = 2066,
  DOMParser = 2084,
  DOMPoint = 2094,
  DOMPointReadOnly = 2103,
  DOMQuad = 2120,
  DOMRect = 2128,
  DOMRectList = 2136,
  DOMRectReadOnly = 2148,
  DOMRequest = 2164,
  DOMStringList = 2175,
  DOMStringMap = 2189,
  DOMTokenList = 2202,
  DataTransfer = 2215,
  DataTransferItem = 2228,
  DataTransferItemList = 2245,
  DebuggerNotification = 2266,
  DebuggerNotificationObserver = 2287,
  DedicatedWorkerGlobalScope = 2316,
  DelayNode = 2343,
  DeprecationReportBody = 2353,
  DeviceAcceleration = 2375,
  DeviceLightEvent = 2394,
  DeviceMotionEvent = 2411,
  DeviceOrientationEvent = 2429,
  DeviceRotationRate = 2452,
  Directory = 2471,
  Document = 2481,
  DocumentFragment = 2490,
  DocumentL10n = 2507,
  DocumentTimeline = 2520,
  DocumentType = 2537,
  DominatorTree = 2550,
  DragEvent = 2564,
  DynamicsCompressorNode = 2574,
  EXT_blend_minmax = 2597,
  EXT_color_buffer_float = 2614,
  EXT_color_buffer_half_float = 2637,
  EXT_disjoint_timer_query = 2665,
  EXT_float_blend = 2690,
  EXT_frag_depth = 2706,
  EXT_sRGB = 2721,
  EXT_shader_texture_lod = 2730,
  EXT_texture_compression_bptc = 2753,
  EXT_texture_compression_rgtc = 2782,
  EXT_texture_filter_anisotropic = 2811,
  EXT_texture_norm16 = 2842,
  Element = 2861,
  ElementInternals = 2869,
  ErrorEvent = 2886,
  Event = 2897,
  EventCallbackDebuggerNotification = 2903,
  EventCounts = 2937,
  EventSource = 2949,
  EventTarget = 2961,
  Exception = 2973,
  ExtendableEvent = 2983,
  ExtendableMessageEvent = 2999,
  ExtensionAlarms = 3022,
  ExtensionBrowser = 3038,
  ExtensionEventManager = 3055,
  ExtensionMockAPI = 3077,
  ExtensionPort = 3094,
  ExtensionRuntime = 3108,
  ExtensionScripting = 3125,
  ExtensionTest = 3144,
  External = 3158,
  FeaturePolicy = 3167,
  FeaturePolicyViolationReportBody = 3181,
  FetchEvent = 3214,
  FetchObserver = 3225,
  File = 3239,
  FileList = 3244,
  FileReader = 3253,
  FileReaderSync = 3264,
  FileSystem = 3279,
  FileSystemDirectoryEntry = 3290,
  FileSystemDirectoryHandle = 3315,
  FileSystemDirectoryHandle_AsyncIterator = 3341,
  FileSystemDirectoryIterator = 3381,
  FileSystemDirectoryReader = 3409,
  FileSystemEntry = 3435,
  FileSystemFileEntry = 3451,
  FileSystemFileHandle = 3471,
  FileSystemHandle = 3492,
  FileSystemSyncAccessHandle = 3509,
  FileSystemWritableFileStream = 3536,
  Flex = 3565,
  FlexItemValues = 3570,
  FlexLineValues = 3585,
  FluentBundle = 3600,
  FluentBundleAsyncIterator = 3613,
  FluentBundleIterator = 3639,
  FluentPattern = 3660,
  FluentResource = 3674,
  FocusEvent = 3689,
  FontFace = 3700,
  FontFaceSet = 3709,
  FontFaceSetIterator = 3721,
  FontFaceSetLoadEvent = 3741,
  FormData = 3762,
  FormData_Iterator = 3771,
  FormDataEvent = 3789,
  FrameCrashedEvent = 3803,
  FrameLoader = 3821,
  GPU = 3833,
  GPUAdapter = 3837,
  GPUBindGroup = 3848,
  GPUBindGroupLayout = 3861,
  GPUBuffer = 3880,
  GPUBufferUsage = 3890,
  GPUCanvasContext = 3905,
  GPUColorWrite = 3922,
  GPUCommandBuffer = 3936,
  GPUCommandEncoder = 3953,
  GPUCompilationInfo = 3971,
  GPUCompilationMessage = 3990,
  GPUComputePassEncoder = 4012,
  GPUComputePipeline = 4034,
  GPUDevice = 4053,
  GPUDeviceLostInfo = 4063,
  GPUMapMode = 4081,
  GPUOutOfMemoryError = 4092,
  GPUPipelineLayout = 4112,
  GPUQuerySet = 4130,
  GPUQueue = 4142,
  GPURenderBundle = 4151,
  GPURenderBundleEncoder = 4167,
  GPURenderPassEncoder = 4190,
  GPURenderPipeline = 4211,
  GPUSampler = 4229,
  GPUShaderModule = 4240,
  GPUShaderStage = 4256,
  GPUSupportedFeatures = 4271,
  GPUSupportedLimits = 4292,
  GPUTexture = 4311,
  GPUTextureUsage = 4322,
  GPUTextureView = 4338,
  GPUUncapturedErrorEvent = 4353,
  GPUValidationError = 4377,
  GainNode = 4396,
  Gamepad = 4405,
  GamepadAxisMoveEvent = 4413,
  GamepadButton = 4434,
  GamepadButtonEvent = 4448,
  GamepadEvent = 4467,
  GamepadHapticActuator = 4480,
  GamepadLightIndicator = 4502,
  GamepadPose = 4524,
  GamepadServiceTest = 4536,
  GamepadTouch = 4555,
  Geolocation = 4568,
  GeolocationCoordinates = 4580,
  GeolocationPosition = 4603,
  GeolocationPositionError = 4623,
  GetUserMediaRequest = 4648,
  GleanCategory = 4668,
  GleanImpl = 4682,
  GleanLabeled = 4692,
  GleanPingsImpl = 4705,
  Grid = 4720,
  GridArea = 4725,
  GridDimension = 4734,
  GridLine = 4748,
  GridLines = 4757,
  GridTrack = 4767,
  GridTracks = 4777,
  HTMLAllCollection = 4788,
  HTMLAnchorElement = 4806,
  HTMLAreaElement = 4824,
  HTMLAudioElement = 4840,
  HTMLBRElement = 4857,
  HTMLBaseElement = 4871,
  HTMLBodyElement = 4887,
  HTMLButtonElement = 4903,
  HTMLCanvasElement = 4921,
  HTMLCollection = 4939,
  HTMLDListElement = 4954,
  HTMLDataElement = 4971,
  HTMLDataListElement = 4987,
  HTMLDetailsElement = 5007,
  HTMLDialogElement = 5026,
  HTMLDirectoryElement = 5044,
  HTMLDivElement = 5065,
  HTMLDocument = 5080,
  HTMLElement = 5093,
  HTMLEmbedElement = 5105,
  HTMLFieldSetElement = 5122,
  HTMLFontElement = 5142,
  HTMLFormControlsCollection = 5158,
  HTMLFormElement = 5185,
  HTMLFrameElement = 5201,
  HTMLFrameSetElement = 5218,
  HTMLHRElement = 5238,
  HTMLHeadElement = 5252,
  HTMLHeadingElement = 5268,
  HTMLHtmlElement = 5287,
  HTMLIFrameElement = 5303,
  HTMLImageElement = 5321,
  HTMLInputElement = 5338,
  HTMLLIElement = 5355,
  HTMLLabelElement = 5369,
  HTMLLegendElement = 5386,
  HTMLLinkElement = 5404,
  HTMLMapElement = 5420,
  HTMLMarqueeElement = 5435,
  HTMLMediaElement = 5454,
  HTMLMenuElement = 5471,
  HTMLMetaElement = 5487,
  HTMLMeterElement = 5503,
  HTMLModElement = 5520,
  HTMLOListElement = 5535,
  HTMLObjectElement = 5552,
  HTMLOptGroupElement = 5570,
  HTMLOptionElement = 5590,
  HTMLOptionsCollection = 5608,
  HTMLOutputElement = 5630,
  HTMLParagraphElement = 5648,
  HTMLParamElement = 5669,
  HTMLPictureElement = 5686,
  HTMLPreElement = 5705,
  HTMLProgressElement = 5720,
  HTMLQuoteElement = 5740,
  HTMLScriptElement = 5757,
  HTMLSelectElement = 5775,
  HTMLSlotElement = 5793,
  HTMLSourceElement = 5809,
  HTMLSpanElement = 5827,
  HTMLStyleElement = 5843,
  HTMLTableCaptionElement = 5860,
  HTMLTableCellElement = 5884,
  HTMLTableColElement = 5905,
  HTMLTableElement = 5925,
  HTMLTableRowElement = 5942,
  HTMLTableSectionElement = 5962,
  HTMLTemplateElement = 5986,
  HTMLTextAreaElement = 6006,
  HTMLTimeElement = 6026,
  HTMLTitleElement = 6042,
  HTMLTrackElement = 6059,
  HTMLUListElement = 6076,
  HTMLUnknownElement = 6093,
  HTMLVideoElement = 6112,
  HashChangeEvent = 6129,
  Headers = 6145,
  Headers_Iterator = 6153,
  HeapSnapshot = 6170,
  History = 6183,
  IDBCursor = 6191,
  IDBCursorWithValue = 6201,
  IDBDatabase = 6220,
  IDBFactory = 6232,
  IDBFileHandle = 6243,
  IDBFileRequest = 6257,
  IDBIndex = 6272,
  IDBKeyRange = 6281,
  IDBLocaleAwareKeyRange = 6293,
  IDBMutableFile = 6316,
  IDBObjectStore = 6331,
  IDBOpenDBRequest = 6346,
  IDBRequest = 6363,
  IDBTransaction = 6374,
  IDBVersionChangeEvent = 6389,
  IIRFilterNode = 6411,
  IOUtils = 6425,
  IdentityCredential = 6433,
  IdleDeadline = 6452,
  Image = 6465,
  ImageBitmap = 6471,
  ImageBitmapRenderingContext = 6483,
  ImageCapture = 6511,
  ImageCaptureError = 6524,
  ImageCaptureErrorEvent = 6542,
  ImageData = 6565,
  ImageDocument = 6575,
  InputEvent = 6589,
  InspectorFontFace = 6600,
  InspectorUtils = 6618,
  InstallTriggerImpl = 6633,
  IntersectionObserver = 6652,
  IntersectionObserverEntry = 6673,
  IntlUtils = 6699,
  JSProcessActorChild = 6709,
  JSProcessActorParent = 6729,
  JSWindowActorChild = 6750,
  JSWindowActorParent = 6769,
  KeyEvent = 6789,
  KeyboardEvent = 6798,
  KeyframeEffect = 6812,
  L10nFileSource = 6827,
  L10nOverlays = 6842,
  L10nRegistry = 6855,
  LegacyMozTCPSocket = 6868,
  Localization = 6887,
  Location = 6900,
  Lock = 6909,
  LockManager = 6914,
  MIDIAccess = 6926,
  MIDIConnectionEvent = 6937,
  MIDIInput = 6957,
  MIDIInputMap = 6967,
  MIDIMessageEvent = 6980,
  MIDIOutput = 6997,
  MIDIOutputMap = 7008,
  MIDIPort = 7022,
  MOZ_debug = 7031,
  MatchGlob = 7041,
  MatchPattern = 7051,
  MatchPatternSet = 7064,
  MathMLElement = 7080,
  MediaCapabilities = 7094,
  MediaCapabilitiesInfo = 7112,
  MediaControlService = 7134,
  MediaController = 7154,
  MediaDeviceInfo = 7170,
  MediaDevices = 7186,
  MediaElementAudioSourceNode = 7199,
  MediaEncryptedEvent = 7227,
  MediaError = 7247,
  MediaKeyError = 7258,
  MediaKeyMessageEvent = 7272,
  MediaKeySession = 7293,
  MediaKeyStatusMap = 7309,
  MediaKeyStatusMap_Iterator = 7327,
  MediaKeySystemAccess = 7354,
  MediaKeys = 7375,
  MediaList = 7385,
  MediaMetadata = 7395,
  MediaQueryList = 7409,
  MediaQueryListEvent = 7424,
  MediaRecorder = 7444,
  MediaRecorderErrorEvent = 7458,
  MediaSession = 7482,
  MediaSource = 7495,
  MediaStream = 7507,
  MediaStreamAudioDestinationNode = 7519,
  MediaStreamAudioSourceNode = 7551,
  MediaStreamError = 7578,
  MediaStreamEvent = 7595,
  MediaStreamTrack = 7612,
  MediaStreamTrackAudioSourceNode = 7629,
  MediaStreamTrackEvent = 7661,
  MerchantValidationEvent = 7683,
  MessageBroadcaster = 7707,
  MessageChannel = 7726,
  MessageEvent = 7741,
  MessageListenerManager = 7754,
  MessagePort = 7777,
  MessageSender = 7789,
  MimeType = 7803,
  MimeTypeArray = 7812,
  MouseEvent = 7826,
  MouseScrollEvent = 7837,
  MozCanvasPrintState = 7854,
  MozDocumentMatcher = 7874,
  MozDocumentObserver = 7893,
  MozQueryInterface = 7913,
  MozSharedMap = 7931,
  MozSharedMap_Iterator = 7944,
  MozSharedMapChangeEvent = 7966,
  MozStorageAsyncStatementParams = 7990,
  MozStorageStatementParams = 8021,
  MozStorageStatementRow = 8047,
  MozWritableSharedMap = 8070,
  MutationEvent = 8091,
  MutationObserver = 8105,
  MutationRecord = 8122,
  NamedNodeMap = 8137,
  NavigationPreloadManager = 8150,
  Navigator = 8175,
  NetworkInformation = 8185,
  Node = 8204,
  NodeFilter = 8209,
  NodeIterator = 8220,
  NodeList = 8233,
  Notification = 8242,
  NotificationEvent = 8255,
  NotifyPaintEvent = 8273,
  OES_draw_buffers_indexed = 8290,
  OES_element_index_uint = 8315,
  OES_fbo_render_mipmap = 8338,
  OES_standard_derivatives = 8360,
  OES_texture_float = 8385,
  OES_texture_float_linear = 8403,
  OES_texture_half_float = 8428,
  OES_texture_half_float_linear = 8451,
  OES_vertex_array_object = 8481,
  OVR_multiview2 = 8505,
  OfflineAudioCompletionEvent = 8520,
  OfflineAudioContext = 8548,
  OfflineResourceList = 8568,
  OffscreenCanvas = 8588,
  OffscreenCanvasRenderingContext2D = 8604,
  Option = 8638,
  OscillatorNode = 8645,
  PageTransitionEvent = 8660,
  PaintRequest = 8680,
  PaintRequestList = 8693,
  PaintWorkletGlobalScope = 8710,
  PannerNode = 8734,
  ParentProcessMessageManager = 8745,
  Path2D = 8773,
  PathUtils = 8780,
  PaymentAddress = 8790,
  PaymentMethodChangeEvent = 8805,
  PaymentRequest = 8830,
  PaymentRequestUpdateEvent = 8845,
  PaymentResponse = 8871,
  PeerConnectionImpl = 8887,
  PeerConnectionObserver = 8906,
  Performance = 8929,
  PerformanceEntry = 8941,
  PerformanceEntryEvent = 8958,
  PerformanceEventTiming = 8980,
  PerformanceMark = 9003,
  PerformanceMeasure = 9019,
  PerformanceNavigation = 9038,
  PerformanceNavigationTiming = 9060,
  PerformanceObserver = 9088,
  PerformanceObserverEntryList = 9108,
  PerformancePaintTiming = 9137,
  PerformanceResourceTiming = 9160,
  PerformanceServerTiming = 9186,
  PerformanceTiming = 9210,
  PeriodicWave = 9228,
  PermissionStatus = 9241,
  Permissions = 9258,
  PlacesBookmark = 9270,
  PlacesBookmarkAddition = 9285,
  PlacesBookmarkChanged = 9308,
  PlacesBookmarkGuid = 9330,
  PlacesBookmarkMoved = 9349,
  PlacesBookmarkRemoved = 9369,
  PlacesBookmarkTags = 9391,
  PlacesBookmarkTime = 9410,
  PlacesBookmarkTitle = 9429,
  PlacesBookmarkUrl = 9449,
  PlacesEvent = 9467,
  PlacesFavicon = 9479,
  PlacesHistoryCleared = 9493,
  PlacesObservers = 9514,
  PlacesPurgeCaches = 9530,
  PlacesRanking = 9548,
  PlacesVisit = 9562,
  PlacesVisitRemoved = 9574,
  PlacesVisitTitle = 9593,
  PlacesWeakCallbackWrapper = 9610,
  Plugin = 9636,
  PluginArray = 9643,
  PluginCrashedEvent = 9655,
  PointerEvent = 9674,
  PopStateEvent = 9687,
  PopupBlockedEvent = 9701,
  PopupPositionedEvent = 9719,
  PositionStateEvent = 9740,
  PrecompiledScript = 9759,
  PrioEncoder = 9777,
  ProcessMessageManager = 9789,
  ProcessingInstruction = 9811,
  ProgressEvent = 9833,
  PromiseDebugging = 9847,
  PromiseNativeHandler = 9864,
  PromiseRejectionEvent = 9885,
  PublicKeyCredential = 9907,
  PushEvent = 9927,
  PushManager = 9937,
  PushManagerImpl = 9949,
  PushMessageData = 9965,
  PushSubscription = 9981,
  PushSubscriptionOptions = 9998,
  RTCCertificate = 10022,
  RTCDTMFSender = 10037,
  RTCDTMFToneChangeEvent = 10051,
  RTCDataChannel = 10074,
  RTCDataChannelEvent = 10089,
  RTCDtlsTransport = 10109,
  RTCIceCandidate = 10126,
  RTCIdentityProviderRegistrar = 10142,
  RTCPeerConnection = 10171,
  RTCPeerConnectionIceEvent = 10189,
  RTCPeerConnectionStatic = 10215,
  RTCRtpReceiver = 10239,
  RTCRtpSender = 10254,
  RTCRtpTransceiver = 10267,
  RTCSessionDescription = 10285,
  RTCStatsReport = 10307,
  RTCTrackEvent = 10322,
  RadioNodeList = 10336,
  Range = 10350,
  ReadableByteStreamController = 10356,
  ReadableStream = 10385,
  ReadableStreamBYOBReader = 10400,
  ReadableStreamBYOBRequest = 10425,
  ReadableStreamDefaultController = 10451,
  ReadableStreamDefaultReader = 10483,
  Report = 10511,
  ReportBody = 10518,
  ReportingObserver = 10529,
  Request = 10547,
  ResizeObserver = 10555,
  ResizeObserverEntry = 10570,
  ResizeObserverSize = 10590,
  Response = 10609,
  SVGAElement = 10618,
  SVGAngle = 10630,
  SVGAnimateElement = 10639,
  SVGAnimateMotionElement = 10657,
  SVGAnimateTransformElement = 10681,
  SVGAnimatedAngle = 10708,
  SVGAnimatedBoolean = 10725,
  SVGAnimatedEnumeration = 10744,
  SVGAnimatedInteger = 10767,
  SVGAnimatedLength = 10786,
  SVGAnimatedLengthList = 10804,
  SVGAnimatedNumber = 10826,
  SVGAnimatedNumberList = 10844,
  SVGAnimatedPreserveAspectRatio = 10866,
  SVGAnimatedRect = 10897,
  SVGAnimatedString = 10913,
  SVGAnimatedTransformList = 10931,
  SVGAnimationElement = 10956,
  SVGCircleElement = 10976,
  SVGClipPathElement = 10993,
  SVGComponentTransferFunctionElement = 11012,
  SVGDefsElement = 11048,
  SVGDescElement = 11063,
  SVGElement = 11078,
  SVGEllipseElement = 11089,
  SVGFEBlendElement = 11107,
  SVGFEColorMatrixElement = 11125,
  SVGFEComponentTransferElement = 11149,
  SVGFECompositeElement = 11179,
  SVGFEConvolveMatrixElement = 11201,
  SVGFEDiffuseLightingElement = 11228,
  SVGFEDisplacementMapElement = 11256,
  SVGFEDistantLightElement = 11284,
  SVGFEDropShadowElement = 11309,
  SVGFEFloodElement = 11332,
  SVGFEFuncAElement = 11350,
  SVGFEFuncBElement = 11368,
  SVGFEFuncGElement = 11386,
  SVGFEFuncRElement = 11404,
  SVGFEGaussianBlurElement = 11422,
  SVGFEImageElement = 11447,
  SVGFEMergeElement = 11465,
  SVGFEMergeNodeElement = 11483,
  SVGFEMorphologyElement = 11505,
  SVGFEOffsetElement = 11528,
  SVGFEPointLightElement = 11547,
  SVGFESpecularLightingElement = 11570,
  SVGFESpotLightElement = 11599,
  SVGFETileElement = 11621,
  SVGFETurbulenceElement = 11638,
  SVGFilterElement = 11661,
  SVGForeignObjectElement = 11678,
  SVGGElement = 11702,
  SVGGeometryElement = 11714,
  SVGGradientElement = 11733,
  SVGGraphicsElement = 11752,
  SVGImageElement = 11771,
  SVGLength = 11787,
  SVGLengthList = 11797,
  SVGLineElement = 11811,
  SVGLinearGradientElement = 11826,
  SVGMPathElement = 11851,
  SVGMarkerElement = 11867,
  SVGMaskElement = 11884,
  SVGMatrix = 11899,
  SVGMetadataElement = 11909,
  SVGNumber = 11928,
  SVGNumberList = 11938,
  SVGPathElement = 11952,
  SVGPathSeg = 11967,
  SVGPathSegArcAbs = 11978,
  SVGPathSegArcRel = 11995,
  SVGPathSegClosePath = 12012,
  SVGPathSegCurvetoCubicAbs = 12032,
  SVGPathSegCurvetoCubicRel = 12058,
  SVGPathSegCurvetoCubicSmoothAbs = 12084,
  SVGPathSegCurvetoCubicSmoothRel = 12116,
  SVGPathSegCurvetoQuadraticAbs = 12148,
  SVGPathSegCurvetoQuadraticRel = 12178,
  SVGPathSegCurvetoQuadraticSmoothAbs = 12208,
  SVGPathSegCurvetoQuadraticSmoothRel = 12244,
  SVGPathSegLinetoAbs = 12280,
  SVGPathSegLinetoHorizontalAbs = 12300,
  SVGPathSegLinetoHorizontalRel = 12330,
  SVGPathSegLinetoRel = 12360,
  SVGPathSegLinetoVerticalAbs = 12380,
  SVGPathSegLinetoVerticalRel = 12408,
  SVGPathSegList = 12436,
  SVGPathSegMovetoAbs = 12451,
  SVGPathSegMovetoRel = 12471,
  SVGPatternElement = 12491,
  SVGPoint = 12509,
  SVGPointList = 12518,
  SVGPolygonElement = 12531,
  SVGPolylineElement = 12549,
  SVGPreserveAspectRatio = 12568,
  SVGRadialGradientElement = 12591,
  SVGRect = 12616,
  SVGRectElement = 12624,
  SVGSVGElement = 12639,
  SVGScriptElement = 12653,
  SVGSetElement = 12670,
  SVGStopElement = 12684,
  SVGStringList = 12699,
  SVGStyleElement = 12713,
  SVGSwitchElement = 12729,
  SVGSymbolElement = 12746,
  SVGTSpanElement = 12763,
  SVGTextContentElement = 12779,
  SVGTextElement = 12801,
  SVGTextPathElement = 12816,
  SVGTextPositioningElement = 12835,
  SVGTitleElement = 12861,
  SVGTransform = 12877,
  SVGTransformList = 12890,
  SVGUnitTypes = 12907,
  SVGUseElement = 12920,
  SVGViewElement = 12934,
  Sanitizer = 12949,
  Scheduler = 12959,
  Screen = 12969,
  ScreenLuminance = 12976,
  ScreenOrientation = 12992,
  ScriptProcessorNode = 13010,
  ScrollAreaEvent = 13030,
  ScrollViewChangeEvent = 13046,
  SecurityPolicyViolationEvent = 13068,
  Selection = 13097,
  ServiceWorker = 13107,
  ServiceWorkerContainer = 13121,
  ServiceWorkerGlobalScope = 13144,
  ServiceWorkerRegistration = 13169,
  SessionStoreFormData = 13195,
  SessionStoreScrollData = 13216,
  SessionStoreUtils = 13239,
  ShadowRealmGlobalScope = 13257,
  ShadowRoot = 13280,
  SharedWorker = 13291,
  SharedWorkerGlobalScope = 13304,
  SimpleGestureEvent = 13328,
  SourceBuffer = 13347,
  SourceBufferList = 13360,
  SpeechGrammar = 13377,
  SpeechGrammarList = 13391,
  SpeechRecognition = 13409,
  SpeechRecognitionAlternative = 13427,
  SpeechRecognitionError = 13456,
  SpeechRecognitionEvent = 13479,
  SpeechRecognitionResult = 13502,
  SpeechRecognitionResultList = 13526,
  SpeechSynthesis = 13554,
  SpeechSynthesisErrorEvent = 13570,
  SpeechSynthesisEvent = 13596,
  SpeechSynthesisUtterance = 13617,
  SpeechSynthesisVoice = 13642,
  StaticRange = 13663,
  StereoPannerNode = 13675,
  Storage = 13692,
  StorageEvent = 13700,
  StorageManager = 13713,
  StreamFilter = 13728,
  StreamFilterDataEvent = 13741,
  StructuredCloneHolder = 13763,
  StructuredCloneTester = 13785,
  StyleSheet = 13807,
  StyleSheetApplicableStateChangeEvent = 13818,
  StyleSheetList = 13855,
  SubmitEvent = 13870,
  SubtleCrypto = 13882,
  SyncMessageSender = 13895,
  SyncReadFile = 13913,
  TCPServerSocket = 13926,
  TCPServerSocketEvent = 13942,
  TCPSocket = 13963,
  TCPSocketErrorEvent = 13973,
  TCPSocketEvent = 13993,
  TaskController = 14008,
  TaskPriorityChangeEvent = 14023,
  TaskSignal = 14047,
  TelemetryStopwatch = 14058,
  TestUtils = 14077,
  TestingDeprecatedInterface = 14087,
  Text = 14114,
  TextClause = 14119,
  TextDecoder = 14130,
  TextDecoderStream = 14142,
  TextEncoder = 14160,
  TextEncoderStream = 14172,
  TextMetrics = 14190,
  TextTrack = 14202,
  TextTrackCue = 14212,
  TextTrackCueList = 14225,
  TextTrackList = 14242,
  TimeEvent = 14256,
  TimeRanges = 14266,
  Touch = 14277,
  TouchEvent = 14283,
  TouchList = 14294,
  TrackEvent = 14304,
  TransformStream = 14315,
  TransformStreamDefaultController = 14331,
  TransitionEvent = 14364,
  TreeColumn = 14380,
  TreeColumns = 14391,
  TreeContentView = 14403,
  TreeWalker = 14419,
  U2F = 14430,
  UDPMessageEvent = 14434,
  UDPSocket = 14450,
  UIEvent = 14460,
  URL = 14468,
  URLSearchParams = 14472,
  URLSearchParams_Iterator = 14488,
  UniFFIPointer = 14513,
  UniFFIScaffolding = 14527,
  UserInteraction = 14545,
  UserProximityEvent = 14561,
  VRDisplay = 14580,
  VRDisplayCapabilities = 14590,
  VRDisplayEvent = 14612,
  VREyeParameters = 14627,
  VRFieldOfView = 14643,
  VRFrameData = 14657,
  VRMockController = 14669,
  VRMockDisplay = 14686,
  VRPose = 14700,
  VRServiceTest = 14707,
  VRStageParameters = 14721,
  VTTCue = 14739,
  VTTRegion = 14746,
  ValidityState = 14756,
  VideoColorSpace = 14770,
  VideoFrame = 14786,
  VideoPlaybackQuality = 14797,
  VideoTrack = 14818,
  VideoTrackList = 14829,
  VisualViewport = 14844,
  WEBGL_color_buffer_float = 14859,
  WEBGL_compressed_texture_astc = 14884,
  WEBGL_compressed_texture_etc = 14914,
  WEBGL_compressed_texture_etc1 = 14943,
  WEBGL_compressed_texture_pvrtc = 14973,
  WEBGL_compressed_texture_s3tc = 15004,
  WEBGL_compressed_texture_s3tc_srgb = 15034,
  WEBGL_debug_renderer_info = 15069,
  WEBGL_debug_shaders = 15095,
  WEBGL_depth_texture = 15115,
  WEBGL_draw_buffers = 15135,
  WEBGL_explicit_present = 15154,
  WEBGL_lose_context = 15177,
  WaveShaperNode = 15196,
  WebExtensionContentScript = 15211,
  WebExtensionPolicy = 15237,
  WebGL2RenderingContext = 15256,
  WebGLActiveInfo = 15279,
  WebGLBuffer = 15295,
  WebGLContextEvent = 15307,
  WebGLFramebuffer = 15325,
  WebGLProgram = 15342,
  WebGLQuery = 15355,
  WebGLRenderbuffer = 15366,
  WebGLRenderingContext = 15384,
  WebGLSampler = 15406,
  WebGLShader = 15419,
  WebGLShaderPrecisionFormat = 15431,
  WebGLSync = 15458,
  WebGLTexture = 15468,
  WebGLTransformFeedback = 15481,
  WebGLUniformLocation = 15504,
  WebGLVertexArrayObject = 15525,
  WebKitCSSMatrix = 15548,
  WebSocket = 15564,
  WebrtcGlobalInformation = 15574,
  WheelEvent = 15598,
  Window = 15609,
  WindowClient = 15616,
  WindowContext = 15629,
  WindowGlobalChild = 15643,
  WindowGlobalParent = 15661,
  WindowRoot = 15680,
  Worker = 15691,
  WorkerDebuggerGlobalScope = 15698,
  WorkerGlobalScope = 15724,
  WorkerLocation = 15742,
  WorkerNavigator = 15757,
  WorkerTestUtils = 15773,
  Worklet = 15789,
  WorkletGlobalScope = 15797,
  WritableStream = 15816,
  WritableStreamDefaultController = 15831,
  WritableStreamDefaultWriter = 15863,
  XMLDocument = 15891,
  XMLHttpRequest = 15903,
  XMLHttpRequestEventTarget = 15918,
  XMLHttpRequestUpload = 15944,
  XMLSerializer = 15965,
  XPathEvaluator = 15979,
  XPathExpression = 15994,
  XPathResult = 16010,
  XRBoundedReferenceSpace = 16022,
  XRFrame = 16046,
  XRInputSource = 16054,
  XRInputSourceArray = 16068,
  XRInputSourceEvent = 16087,
  XRInputSourcesChangeEvent = 16106,
  XRPose = 16132,
  XRReferenceSpace = 16139,
  XRReferenceSpaceEvent = 16156,
  XRRenderState = 16178,
  XRRigidTransform = 16192,
  XRSession = 16209,
  XRSessionEvent = 16219,
  XRSpace = 16234,
  XRSystem = 16242,
  XRView = 16251,
  XRViewerPose = 16258,
  XRViewport = 16271,
  XRWebGLLayer = 16282,
  XSLTProcessor = 16295,
  XULCommandEvent = 16309,
  XULElement = 16325,
  XULFrameElement = 16336,
  XULMenuElement = 16352,
  XULPopupElement = 16367,
  XULResizerElement = 16383,
  XULTextElement = 16401,
  XULTreeElement = 16416,
  console = 16431,
  mozRTCIceCandidate = 16439,
  mozRTCPeerConnection = 16458,
  mozRTCSessionDescription = 16479,
  webkitSpeechGrammar = 16504,
  webkitSpeechGrammarList = 16524,
  webkitSpeechRecognition = 16548,
  webkitURL = 16572,
};

namespace binding_detail {
extern const char sBindingNames[];
}  // namespace binding_detail

MOZ_ALWAYS_INLINE const char* BindingName(BindingNamesOffset aOffset) {
  return binding_detail::sBindingNames + static_cast<size_t>(aOffset);
}

} // namespace mozilla::dom


#endif // mozilla_dom_BindingNames_h
