#include "mozilla/EnumTypeTraits.h"
#include "mozilla/dom/BindingNames.h"

namespace mozilla::dom {

namespace binding_detail {

const char sBindingNames[] = {
  /*     0 */ "ANGLE_instanced_arrays" "\0"
  /*    23 */ "APZHitResultFlags" "\0"
  /*    41 */ "AbortController" "\0"
  /*    57 */ "AbortSignal" "\0"
  /*    69 */ "AbstractRange" "\0"
  /*    83 */ "AccessibleNode" "\0"
  /*    98 */ "Addon" "\0"
  /*   104 */ "AddonEvent" "\0"
  /*   115 */ "AddonInstall" "\0"
  /*   128 */ "AddonManager" "\0"
  /*   141 */ "AddonManagerPermissions" "\0"
  /*   165 */ "AnalyserNode" "\0"
  /*   178 */ "Animation" "\0"
  /*   188 */ "AnimationEffect" "\0"
  /*   204 */ "AnimationEvent" "\0"
  /*   219 */ "AnimationPlaybackEvent" "\0"
  /*   242 */ "AnimationTimeline" "\0"
  /*   260 */ "AnonymousContent" "\0"
  /*   277 */ "Attr" "\0"
  /*   282 */ "Audio" "\0"
  /*   288 */ "AudioBuffer" "\0"
  /*   300 */ "AudioBufferSourceNode" "\0"
  /*   322 */ "AudioContext" "\0"
  /*   335 */ "AudioDestinationNode" "\0"
  /*   356 */ "AudioListener" "\0"
  /*   370 */ "AudioNode" "\0"
  /*   380 */ "AudioParam" "\0"
  /*   391 */ "AudioParamMap" "\0"
  /*   405 */ "AudioProcessingEvent" "\0"
  /*   426 */ "AudioScheduledSourceNode" "\0"
  /*   451 */ "AudioTrack" "\0"
  /*   462 */ "AudioTrackList" "\0"
  /*   477 */ "AudioWorklet" "\0"
  /*   490 */ "AudioWorkletGlobalScope" "\0"
  /*   514 */ "AudioWorkletNode" "\0"
  /*   531 */ "AudioWorkletProcessor" "\0"
  /*   553 */ "AuthenticatorAssertionResponse" "\0"
  /*   584 */ "AuthenticatorAttestationResponse" "\0"
  /*   617 */ "AuthenticatorResponse" "\0"
  /*   639 */ "BarProp" "\0"
  /*   647 */ "BaseAudioContext" "\0"
  /*   664 */ "BatteryManager" "\0"
  /*   679 */ "BeforeUnloadEvent" "\0"
  /*   697 */ "BiquadFilterNode" "\0"
  /*   714 */ "Blob" "\0"
  /*   719 */ "BlobEvent" "\0"
  /*   729 */ "BroadcastChannel" "\0"
  /*   746 */ "BrowsingContext" "\0"
  /*   762 */ "BrowsingContextGroup" "\0"
  /*   783 */ "ByteLengthQueuingStrategy" "\0"
  /*   809 */ "CDATASection" "\0"
  /*   822 */ "CSS" "\0"
  /*   826 */ "CSS2Properties" "\0"
  /*   841 */ "CSSAnimation" "\0"
  /*   854 */ "CSSConditionRule" "\0"
  /*   871 */ "CSSContainerRule" "\0"
  /*   888 */ "CSSCounterStyleRule" "\0"
  /*   908 */ "CSSFontFaceRule" "\0"
  /*   924 */ "CSSFontFeatureValuesRule" "\0"
  /*   949 */ "CSSFontPaletteValuesRule" "\0"
  /*   974 */ "CSSGroupingRule" "\0"
  /*   990 */ "CSSImportRule" "\0"
  /*  1004 */ "CSSKeyframeRule" "\0"
  /*  1020 */ "CSSKeyframesRule" "\0"
  /*  1037 */ "CSSLayerBlockRule" "\0"
  /*  1055 */ "CSSLayerStatementRule" "\0"
  /*  1077 */ "CSSMediaRule" "\0"
  /*  1090 */ "CSSMozDocumentRule" "\0"
  /*  1109 */ "CSSNamespaceRule" "\0"
  /*  1126 */ "CSSPageRule" "\0"
  /*  1138 */ "CSSPseudoElement" "\0"
  /*  1155 */ "CSSRule" "\0"
  /*  1163 */ "CSSRuleList" "\0"
  /*  1175 */ "CSSStyleDeclaration" "\0"
  /*  1195 */ "CSSStyleRule" "\0"
  /*  1208 */ "CSSStyleSheet" "\0"
  /*  1222 */ "CSSSupportsRule" "\0"
  /*  1238 */ "CSSTransition" "\0"
  /*  1252 */ "Cache" "\0"
  /*  1258 */ "CacheStorage" "\0"
  /*  1271 */ "CallbackDebuggerNotification" "\0"
  /*  1300 */ "CanonicalBrowsingContext" "\0"
  /*  1325 */ "CanvasCaptureMediaStream" "\0"
  /*  1350 */ "CanvasGradient" "\0"
  /*  1365 */ "CanvasPattern" "\0"
  /*  1379 */ "CanvasRenderingContext2D" "\0"
  /*  1404 */ "CaretPosition" "\0"
  /*  1418 */ "CaretStateChangedEvent" "\0"
  /*  1441 */ "ChannelMergerNode" "\0"
  /*  1459 */ "ChannelSplitterNode" "\0"
  /*  1479 */ "ChannelWrapper" "\0"
  /*  1494 */ "CharacterData" "\0"
  /*  1508 */ "CheckerboardReportService" "\0"
  /*  1534 */ "ChildProcessMessageManager" "\0"
  /*  1561 */ "ChildSHistory" "\0"
  /*  1575 */ "ChromeMessageBroadcaster" "\0"
  /*  1600 */ "ChromeMessageSender" "\0"
  /*  1620 */ "ChromeNodeList" "\0"
  /*  1635 */ "ChromeUtils" "\0"
  /*  1647 */ "ChromeWorker" "\0"
  /*  1660 */ "Client" "\0"
  /*  1667 */ "Clients" "\0"
  /*  1675 */ "Clipboard" "\0"
  /*  1685 */ "ClipboardEvent" "\0"
  /*  1700 */ "ClipboardItem" "\0"
  /*  1714 */ "ClonedErrorHolder" "\0"
  /*  1732 */ "CloseEvent" "\0"
  /*  1743 */ "CommandEvent" "\0"
  /*  1756 */ "Comment" "\0"
  /*  1764 */ "CompositionEvent" "\0"
  /*  1781 */ "ConsoleInstance" "\0"
  /*  1797 */ "ConstantSourceNode" "\0"
  /*  1816 */ "ContentFrameMessageManager" "\0"
  /*  1843 */ "ContentProcessMessageManager" "\0"
  /*  1872 */ "ConvolverNode" "\0"
  /*  1886 */ "CountQueuingStrategy" "\0"
  /*  1907 */ "CreateOfferRequest" "\0"
  /*  1926 */ "Credential" "\0"
  /*  1937 */ "CredentialsContainer" "\0"
  /*  1958 */ "Crypto" "\0"
  /*  1965 */ "CryptoKey" "\0"
  /*  1975 */ "CustomElementRegistry" "\0"
  /*  1997 */ "CustomEvent" "\0"
  /*  2009 */ "DOMException" "\0"
  /*  2022 */ "DOMImplementation" "\0"
  /*  2040 */ "DOMLocalization" "\0"
  /*  2056 */ "DOMMatrix" "\0"
  /*  2066 */ "DOMMatrixReadOnly" "\0"
  /*  2084 */ "DOMParser" "\0"
  /*  2094 */ "DOMPoint" "\0"
  /*  2103 */ "DOMPointReadOnly" "\0"
  /*  2120 */ "DOMQuad" "\0"
  /*  2128 */ "DOMRect" "\0"
  /*  2136 */ "DOMRectList" "\0"
  /*  2148 */ "DOMRectReadOnly" "\0"
  /*  2164 */ "DOMRequest" "\0"
  /*  2175 */ "DOMStringList" "\0"
  /*  2189 */ "DOMStringMap" "\0"
  /*  2202 */ "DOMTokenList" "\0"
  /*  2215 */ "DataTransfer" "\0"
  /*  2228 */ "DataTransferItem" "\0"
  /*  2245 */ "DataTransferItemList" "\0"
  /*  2266 */ "DebuggerNotification" "\0"
  /*  2287 */ "DebuggerNotificationObserver" "\0"
  /*  2316 */ "DedicatedWorkerGlobalScope" "\0"
  /*  2343 */ "DelayNode" "\0"
  /*  2353 */ "DeprecationReportBody" "\0"
  /*  2375 */ "DeviceAcceleration" "\0"
  /*  2394 */ "DeviceLightEvent" "\0"
  /*  2411 */ "DeviceMotionEvent" "\0"
  /*  2429 */ "DeviceOrientationEvent" "\0"
  /*  2452 */ "DeviceRotationRate" "\0"
  /*  2471 */ "Directory" "\0"
  /*  2481 */ "Document" "\0"
  /*  2490 */ "DocumentFragment" "\0"
  /*  2507 */ "DocumentL10n" "\0"
  /*  2520 */ "DocumentTimeline" "\0"
  /*  2537 */ "DocumentType" "\0"
  /*  2550 */ "DominatorTree" "\0"
  /*  2564 */ "DragEvent" "\0"
  /*  2574 */ "DynamicsCompressorNode" "\0"
  /*  2597 */ "EXT_blend_minmax" "\0"
  /*  2614 */ "EXT_color_buffer_float" "\0"
  /*  2637 */ "EXT_color_buffer_half_float" "\0"
  /*  2665 */ "EXT_disjoint_timer_query" "\0"
  /*  2690 */ "EXT_float_blend" "\0"
  /*  2706 */ "EXT_frag_depth" "\0"
  /*  2721 */ "EXT_sRGB" "\0"
  /*  2730 */ "EXT_shader_texture_lod" "\0"
  /*  2753 */ "EXT_texture_compression_bptc" "\0"
  /*  2782 */ "EXT_texture_compression_rgtc" "\0"
  /*  2811 */ "EXT_texture_filter_anisotropic" "\0"
  /*  2842 */ "EXT_texture_norm16" "\0"
  /*  2861 */ "Element" "\0"
  /*  2869 */ "ElementInternals" "\0"
  /*  2886 */ "ErrorEvent" "\0"
  /*  2897 */ "Event" "\0"
  /*  2903 */ "EventCallbackDebuggerNotification" "\0"
  /*  2937 */ "EventCounts" "\0"
  /*  2949 */ "EventSource" "\0"
  /*  2961 */ "EventTarget" "\0"
  /*  2973 */ "Exception" "\0"
  /*  2983 */ "ExtendableEvent" "\0"
  /*  2999 */ "ExtendableMessageEvent" "\0"
  /*  3022 */ "ExtensionAlarms" "\0"
  /*  3038 */ "ExtensionBrowser" "\0"
  /*  3055 */ "ExtensionEventManager" "\0"
  /*  3077 */ "ExtensionMockAPI" "\0"
  /*  3094 */ "ExtensionPort" "\0"
  /*  3108 */ "ExtensionRuntime" "\0"
  /*  3125 */ "ExtensionScripting" "\0"
  /*  3144 */ "ExtensionTest" "\0"
  /*  3158 */ "External" "\0"
  /*  3167 */ "FeaturePolicy" "\0"
  /*  3181 */ "FeaturePolicyViolationReportBody" "\0"
  /*  3214 */ "FetchEvent" "\0"
  /*  3225 */ "FetchObserver" "\0"
  /*  3239 */ "File" "\0"
  /*  3244 */ "FileList" "\0"
  /*  3253 */ "FileReader" "\0"
  /*  3264 */ "FileReaderSync" "\0"
  /*  3279 */ "FileSystem" "\0"
  /*  3290 */ "FileSystemDirectoryEntry" "\0"
  /*  3315 */ "FileSystemDirectoryHandle" "\0"
  /*  3341 */ "FileSystemDirectoryHandle AsyncIterator" "\0"
  /*  3381 */ "FileSystemDirectoryIterator" "\0"
  /*  3409 */ "FileSystemDirectoryReader" "\0"
  /*  3435 */ "FileSystemEntry" "\0"
  /*  3451 */ "FileSystemFileEntry" "\0"
  /*  3471 */ "FileSystemFileHandle" "\0"
  /*  3492 */ "FileSystemHandle" "\0"
  /*  3509 */ "FileSystemSyncAccessHandle" "\0"
  /*  3536 */ "FileSystemWritableFileStream" "\0"
  /*  3565 */ "Flex" "\0"
  /*  3570 */ "FlexItemValues" "\0"
  /*  3585 */ "FlexLineValues" "\0"
  /*  3600 */ "FluentBundle" "\0"
  /*  3613 */ "FluentBundleAsyncIterator" "\0"
  /*  3639 */ "FluentBundleIterator" "\0"
  /*  3660 */ "FluentPattern" "\0"
  /*  3674 */ "FluentResource" "\0"
  /*  3689 */ "FocusEvent" "\0"
  /*  3700 */ "FontFace" "\0"
  /*  3709 */ "FontFaceSet" "\0"
  /*  3721 */ "FontFaceSetIterator" "\0"
  /*  3741 */ "FontFaceSetLoadEvent" "\0"
  /*  3762 */ "FormData" "\0"
  /*  3771 */ "FormData Iterator" "\0"
  /*  3789 */ "FormDataEvent" "\0"
  /*  3803 */ "FrameCrashedEvent" "\0"
  /*  3821 */ "FrameLoader" "\0"
  /*  3833 */ "GPU" "\0"
  /*  3837 */ "GPUAdapter" "\0"
  /*  3848 */ "GPUBindGroup" "\0"
  /*  3861 */ "GPUBindGroupLayout" "\0"
  /*  3880 */ "GPUBuffer" "\0"
  /*  3890 */ "GPUBufferUsage" "\0"
  /*  3905 */ "GPUCanvasContext" "\0"
  /*  3922 */ "GPUColorWrite" "\0"
  /*  3936 */ "GPUCommandBuffer" "\0"
  /*  3953 */ "GPUCommandEncoder" "\0"
  /*  3971 */ "GPUCompilationInfo" "\0"
  /*  3990 */ "GPUCompilationMessage" "\0"
  /*  4012 */ "GPUComputePassEncoder" "\0"
  /*  4034 */ "GPUComputePipeline" "\0"
  /*  4053 */ "GPUDevice" "\0"
  /*  4063 */ "GPUDeviceLostInfo" "\0"
  /*  4081 */ "GPUMapMode" "\0"
  /*  4092 */ "GPUOutOfMemoryError" "\0"
  /*  4112 */ "GPUPipelineLayout" "\0"
  /*  4130 */ "GPUQuerySet" "\0"
  /*  4142 */ "GPUQueue" "\0"
  /*  4151 */ "GPURenderBundle" "\0"
  /*  4167 */ "GPURenderBundleEncoder" "\0"
  /*  4190 */ "GPURenderPassEncoder" "\0"
  /*  4211 */ "GPURenderPipeline" "\0"
  /*  4229 */ "GPUSampler" "\0"
  /*  4240 */ "GPUShaderModule" "\0"
  /*  4256 */ "GPUShaderStage" "\0"
  /*  4271 */ "GPUSupportedFeatures" "\0"
  /*  4292 */ "GPUSupportedLimits" "\0"
  /*  4311 */ "GPUTexture" "\0"
  /*  4322 */ "GPUTextureUsage" "\0"
  /*  4338 */ "GPUTextureView" "\0"
  /*  4353 */ "GPUUncapturedErrorEvent" "\0"
  /*  4377 */ "GPUValidationError" "\0"
  /*  4396 */ "GainNode" "\0"
  /*  4405 */ "Gamepad" "\0"
  /*  4413 */ "GamepadAxisMoveEvent" "\0"
  /*  4434 */ "GamepadButton" "\0"
  /*  4448 */ "GamepadButtonEvent" "\0"
  /*  4467 */ "GamepadEvent" "\0"
  /*  4480 */ "GamepadHapticActuator" "\0"
  /*  4502 */ "GamepadLightIndicator" "\0"
  /*  4524 */ "GamepadPose" "\0"
  /*  4536 */ "GamepadServiceTest" "\0"
  /*  4555 */ "GamepadTouch" "\0"
  /*  4568 */ "Geolocation" "\0"
  /*  4580 */ "GeolocationCoordinates" "\0"
  /*  4603 */ "GeolocationPosition" "\0"
  /*  4623 */ "GeolocationPositionError" "\0"
  /*  4648 */ "GetUserMediaRequest" "\0"
  /*  4668 */ "GleanCategory" "\0"
  /*  4682 */ "GleanImpl" "\0"
  /*  4692 */ "GleanLabeled" "\0"
  /*  4705 */ "GleanPingsImpl" "\0"
  /*  4720 */ "Grid" "\0"
  /*  4725 */ "GridArea" "\0"
  /*  4734 */ "GridDimension" "\0"
  /*  4748 */ "GridLine" "\0"
  /*  4757 */ "GridLines" "\0"
  /*  4767 */ "GridTrack" "\0"
  /*  4777 */ "GridTracks" "\0"
  /*  4788 */ "HTMLAllCollection" "\0"
  /*  4806 */ "HTMLAnchorElement" "\0"
  /*  4824 */ "HTMLAreaElement" "\0"
  /*  4840 */ "HTMLAudioElement" "\0"
  /*  4857 */ "HTMLBRElement" "\0"
  /*  4871 */ "HTMLBaseElement" "\0"
  /*  4887 */ "HTMLBodyElement" "\0"
  /*  4903 */ "HTMLButtonElement" "\0"
  /*  4921 */ "HTMLCanvasElement" "\0"
  /*  4939 */ "HTMLCollection" "\0"
  /*  4954 */ "HTMLDListElement" "\0"
  /*  4971 */ "HTMLDataElement" "\0"
  /*  4987 */ "HTMLDataListElement" "\0"
  /*  5007 */ "HTMLDetailsElement" "\0"
  /*  5026 */ "HTMLDialogElement" "\0"
  /*  5044 */ "HTMLDirectoryElement" "\0"
  /*  5065 */ "HTMLDivElement" "\0"
  /*  5080 */ "HTMLDocument" "\0"
  /*  5093 */ "HTMLElement" "\0"
  /*  5105 */ "HTMLEmbedElement" "\0"
  /*  5122 */ "HTMLFieldSetElement" "\0"
  /*  5142 */ "HTMLFontElement" "\0"
  /*  5158 */ "HTMLFormControlsCollection" "\0"
  /*  5185 */ "HTMLFormElement" "\0"
  /*  5201 */ "HTMLFrameElement" "\0"
  /*  5218 */ "HTMLFrameSetElement" "\0"
  /*  5238 */ "HTMLHRElement" "\0"
  /*  5252 */ "HTMLHeadElement" "\0"
  /*  5268 */ "HTMLHeadingElement" "\0"
  /*  5287 */ "HTMLHtmlElement" "\0"
  /*  5303 */ "HTMLIFrameElement" "\0"
  /*  5321 */ "HTMLImageElement" "\0"
  /*  5338 */ "HTMLInputElement" "\0"
  /*  5355 */ "HTMLLIElement" "\0"
  /*  5369 */ "HTMLLabelElement" "\0"
  /*  5386 */ "HTMLLegendElement" "\0"
  /*  5404 */ "HTMLLinkElement" "\0"
  /*  5420 */ "HTMLMapElement" "\0"
  /*  5435 */ "HTMLMarqueeElement" "\0"
  /*  5454 */ "HTMLMediaElement" "\0"
  /*  5471 */ "HTMLMenuElement" "\0"
  /*  5487 */ "HTMLMetaElement" "\0"
  /*  5503 */ "HTMLMeterElement" "\0"
  /*  5520 */ "HTMLModElement" "\0"
  /*  5535 */ "HTMLOListElement" "\0"
  /*  5552 */ "HTMLObjectElement" "\0"
  /*  5570 */ "HTMLOptGroupElement" "\0"
  /*  5590 */ "HTMLOptionElement" "\0"
  /*  5608 */ "HTMLOptionsCollection" "\0"
  /*  5630 */ "HTMLOutputElement" "\0"
  /*  5648 */ "HTMLParagraphElement" "\0"
  /*  5669 */ "HTMLParamElement" "\0"
  /*  5686 */ "HTMLPictureElement" "\0"
  /*  5705 */ "HTMLPreElement" "\0"
  /*  5720 */ "HTMLProgressElement" "\0"
  /*  5740 */ "HTMLQuoteElement" "\0"
  /*  5757 */ "HTMLScriptElement" "\0"
  /*  5775 */ "HTMLSelectElement" "\0"
  /*  5793 */ "HTMLSlotElement" "\0"
  /*  5809 */ "HTMLSourceElement" "\0"
  /*  5827 */ "HTMLSpanElement" "\0"
  /*  5843 */ "HTMLStyleElement" "\0"
  /*  5860 */ "HTMLTableCaptionElement" "\0"
  /*  5884 */ "HTMLTableCellElement" "\0"
  /*  5905 */ "HTMLTableColElement" "\0"
  /*  5925 */ "HTMLTableElement" "\0"
  /*  5942 */ "HTMLTableRowElement" "\0"
  /*  5962 */ "HTMLTableSectionElement" "\0"
  /*  5986 */ "HTMLTemplateElement" "\0"
  /*  6006 */ "HTMLTextAreaElement" "\0"
  /*  6026 */ "HTMLTimeElement" "\0"
  /*  6042 */ "HTMLTitleElement" "\0"
  /*  6059 */ "HTMLTrackElement" "\0"
  /*  6076 */ "HTMLUListElement" "\0"
  /*  6093 */ "HTMLUnknownElement" "\0"
  /*  6112 */ "HTMLVideoElement" "\0"
  /*  6129 */ "HashChangeEvent" "\0"
  /*  6145 */ "Headers" "\0"
  /*  6153 */ "Headers Iterator" "\0"
  /*  6170 */ "HeapSnapshot" "\0"
  /*  6183 */ "History" "\0"
  /*  6191 */ "IDBCursor" "\0"
  /*  6201 */ "IDBCursorWithValue" "\0"
  /*  6220 */ "IDBDatabase" "\0"
  /*  6232 */ "IDBFactory" "\0"
  /*  6243 */ "IDBFileHandle" "\0"
  /*  6257 */ "IDBFileRequest" "\0"
  /*  6272 */ "IDBIndex" "\0"
  /*  6281 */ "IDBKeyRange" "\0"
  /*  6293 */ "IDBLocaleAwareKeyRange" "\0"
  /*  6316 */ "IDBMutableFile" "\0"
  /*  6331 */ "IDBObjectStore" "\0"
  /*  6346 */ "IDBOpenDBRequest" "\0"
  /*  6363 */ "IDBRequest" "\0"
  /*  6374 */ "IDBTransaction" "\0"
  /*  6389 */ "IDBVersionChangeEvent" "\0"
  /*  6411 */ "IIRFilterNode" "\0"
  /*  6425 */ "IOUtils" "\0"
  /*  6433 */ "IdentityCredential" "\0"
  /*  6452 */ "IdleDeadline" "\0"
  /*  6465 */ "Image" "\0"
  /*  6471 */ "ImageBitmap" "\0"
  /*  6483 */ "ImageBitmapRenderingContext" "\0"
  /*  6511 */ "ImageCapture" "\0"
  /*  6524 */ "ImageCaptureError" "\0"
  /*  6542 */ "ImageCaptureErrorEvent" "\0"
  /*  6565 */ "ImageData" "\0"
  /*  6575 */ "ImageDocument" "\0"
  /*  6589 */ "InputEvent" "\0"
  /*  6600 */ "InspectorFontFace" "\0"
  /*  6618 */ "InspectorUtils" "\0"
  /*  6633 */ "InstallTriggerImpl" "\0"
  /*  6652 */ "IntersectionObserver" "\0"
  /*  6673 */ "IntersectionObserverEntry" "\0"
  /*  6699 */ "IntlUtils" "\0"
  /*  6709 */ "JSProcessActorChild" "\0"
  /*  6729 */ "JSProcessActorParent" "\0"
  /*  6750 */ "JSWindowActorChild" "\0"
  /*  6769 */ "JSWindowActorParent" "\0"
  /*  6789 */ "KeyEvent" "\0"
  /*  6798 */ "KeyboardEvent" "\0"
  /*  6812 */ "KeyframeEffect" "\0"
  /*  6827 */ "L10nFileSource" "\0"
  /*  6842 */ "L10nOverlays" "\0"
  /*  6855 */ "L10nRegistry" "\0"
  /*  6868 */ "LegacyMozTCPSocket" "\0"
  /*  6887 */ "Localization" "\0"
  /*  6900 */ "Location" "\0"
  /*  6909 */ "Lock" "\0"
  /*  6914 */ "LockManager" "\0"
  /*  6926 */ "MIDIAccess" "\0"
  /*  6937 */ "MIDIConnectionEvent" "\0"
  /*  6957 */ "MIDIInput" "\0"
  /*  6967 */ "MIDIInputMap" "\0"
  /*  6980 */ "MIDIMessageEvent" "\0"
  /*  6997 */ "MIDIOutput" "\0"
  /*  7008 */ "MIDIOutputMap" "\0"
  /*  7022 */ "MIDIPort" "\0"
  /*  7031 */ "MOZ_debug" "\0"
  /*  7041 */ "MatchGlob" "\0"
  /*  7051 */ "MatchPattern" "\0"
  /*  7064 */ "MatchPatternSet" "\0"
  /*  7080 */ "MathMLElement" "\0"
  /*  7094 */ "MediaCapabilities" "\0"
  /*  7112 */ "MediaCapabilitiesInfo" "\0"
  /*  7134 */ "MediaControlService" "\0"
  /*  7154 */ "MediaController" "\0"
  /*  7170 */ "MediaDeviceInfo" "\0"
  /*  7186 */ "MediaDevices" "\0"
  /*  7199 */ "MediaElementAudioSourceNode" "\0"
  /*  7227 */ "MediaEncryptedEvent" "\0"
  /*  7247 */ "MediaError" "\0"
  /*  7258 */ "MediaKeyError" "\0"
  /*  7272 */ "MediaKeyMessageEvent" "\0"
  /*  7293 */ "MediaKeySession" "\0"
  /*  7309 */ "MediaKeyStatusMap" "\0"
  /*  7327 */ "MediaKeyStatusMap Iterator" "\0"
  /*  7354 */ "MediaKeySystemAccess" "\0"
  /*  7375 */ "MediaKeys" "\0"
  /*  7385 */ "MediaList" "\0"
  /*  7395 */ "MediaMetadata" "\0"
  /*  7409 */ "MediaQueryList" "\0"
  /*  7424 */ "MediaQueryListEvent" "\0"
  /*  7444 */ "MediaRecorder" "\0"
  /*  7458 */ "MediaRecorderErrorEvent" "\0"
  /*  7482 */ "MediaSession" "\0"
  /*  7495 */ "MediaSource" "\0"
  /*  7507 */ "MediaStream" "\0"
  /*  7519 */ "MediaStreamAudioDestinationNode" "\0"
  /*  7551 */ "MediaStreamAudioSourceNode" "\0"
  /*  7578 */ "MediaStreamError" "\0"
  /*  7595 */ "MediaStreamEvent" "\0"
  /*  7612 */ "MediaStreamTrack" "\0"
  /*  7629 */ "MediaStreamTrackAudioSourceNode" "\0"
  /*  7661 */ "MediaStreamTrackEvent" "\0"
  /*  7683 */ "MerchantValidationEvent" "\0"
  /*  7707 */ "MessageBroadcaster" "\0"
  /*  7726 */ "MessageChannel" "\0"
  /*  7741 */ "MessageEvent" "\0"
  /*  7754 */ "MessageListenerManager" "\0"
  /*  7777 */ "MessagePort" "\0"
  /*  7789 */ "MessageSender" "\0"
  /*  7803 */ "MimeType" "\0"
  /*  7812 */ "MimeTypeArray" "\0"
  /*  7826 */ "MouseEvent" "\0"
  /*  7837 */ "MouseScrollEvent" "\0"
  /*  7854 */ "MozCanvasPrintState" "\0"
  /*  7874 */ "MozDocumentMatcher" "\0"
  /*  7893 */ "MozDocumentObserver" "\0"
  /*  7913 */ "MozQueryInterface" "\0"
  /*  7931 */ "MozSharedMap" "\0"
  /*  7944 */ "MozSharedMap Iterator" "\0"
  /*  7966 */ "MozSharedMapChangeEvent" "\0"
  /*  7990 */ "MozStorageAsyncStatementParams" "\0"
  /*  8021 */ "MozStorageStatementParams" "\0"
  /*  8047 */ "MozStorageStatementRow" "\0"
  /*  8070 */ "MozWritableSharedMap" "\0"
  /*  8091 */ "MutationEvent" "\0"
  /*  8105 */ "MutationObserver" "\0"
  /*  8122 */ "MutationRecord" "\0"
  /*  8137 */ "NamedNodeMap" "\0"
  /*  8150 */ "NavigationPreloadManager" "\0"
  /*  8175 */ "Navigator" "\0"
  /*  8185 */ "NetworkInformation" "\0"
  /*  8204 */ "Node" "\0"
  /*  8209 */ "NodeFilter" "\0"
  /*  8220 */ "NodeIterator" "\0"
  /*  8233 */ "NodeList" "\0"
  /*  8242 */ "Notification" "\0"
  /*  8255 */ "NotificationEvent" "\0"
  /*  8273 */ "NotifyPaintEvent" "\0"
  /*  8290 */ "OES_draw_buffers_indexed" "\0"
  /*  8315 */ "OES_element_index_uint" "\0"
  /*  8338 */ "OES_fbo_render_mipmap" "\0"
  /*  8360 */ "OES_standard_derivatives" "\0"
  /*  8385 */ "OES_texture_float" "\0"
  /*  8403 */ "OES_texture_float_linear" "\0"
  /*  8428 */ "OES_texture_half_float" "\0"
  /*  8451 */ "OES_texture_half_float_linear" "\0"
  /*  8481 */ "OES_vertex_array_object" "\0"
  /*  8505 */ "OVR_multiview2" "\0"
  /*  8520 */ "OfflineAudioCompletionEvent" "\0"
  /*  8548 */ "OfflineAudioContext" "\0"
  /*  8568 */ "OfflineResourceList" "\0"
  /*  8588 */ "OffscreenCanvas" "\0"
  /*  8604 */ "OffscreenCanvasRenderingContext2D" "\0"
  /*  8638 */ "Option" "\0"
  /*  8645 */ "OscillatorNode" "\0"
  /*  8660 */ "PageTransitionEvent" "\0"
  /*  8680 */ "PaintRequest" "\0"
  /*  8693 */ "PaintRequestList" "\0"
  /*  8710 */ "PaintWorkletGlobalScope" "\0"
  /*  8734 */ "PannerNode" "\0"
  /*  8745 */ "ParentProcessMessageManager" "\0"
  /*  8773 */ "Path2D" "\0"
  /*  8780 */ "PathUtils" "\0"
  /*  8790 */ "PaymentAddress" "\0"
  /*  8805 */ "PaymentMethodChangeEvent" "\0"
  /*  8830 */ "PaymentRequest" "\0"
  /*  8845 */ "PaymentRequestUpdateEvent" "\0"
  /*  8871 */ "PaymentResponse" "\0"
  /*  8887 */ "PeerConnectionImpl" "\0"
  /*  8906 */ "PeerConnectionObserver" "\0"
  /*  8929 */ "Performance" "\0"
  /*  8941 */ "PerformanceEntry" "\0"
  /*  8958 */ "PerformanceEntryEvent" "\0"
  /*  8980 */ "PerformanceEventTiming" "\0"
  /*  9003 */ "PerformanceMark" "\0"
  /*  9019 */ "PerformanceMeasure" "\0"
  /*  9038 */ "PerformanceNavigation" "\0"
  /*  9060 */ "PerformanceNavigationTiming" "\0"
  /*  9088 */ "PerformanceObserver" "\0"
  /*  9108 */ "PerformanceObserverEntryList" "\0"
  /*  9137 */ "PerformancePaintTiming" "\0"
  /*  9160 */ "PerformanceResourceTiming" "\0"
  /*  9186 */ "PerformanceServerTiming" "\0"
  /*  9210 */ "PerformanceTiming" "\0"
  /*  9228 */ "PeriodicWave" "\0"
  /*  9241 */ "PermissionStatus" "\0"
  /*  9258 */ "Permissions" "\0"
  /*  9270 */ "PlacesBookmark" "\0"
  /*  9285 */ "PlacesBookmarkAddition" "\0"
  /*  9308 */ "PlacesBookmarkChanged" "\0"
  /*  9330 */ "PlacesBookmarkGuid" "\0"
  /*  9349 */ "PlacesBookmarkMoved" "\0"
  /*  9369 */ "PlacesBookmarkRemoved" "\0"
  /*  9391 */ "PlacesBookmarkTags" "\0"
  /*  9410 */ "PlacesBookmarkTime" "\0"
  /*  9429 */ "PlacesBookmarkTitle" "\0"
  /*  9449 */ "PlacesBookmarkUrl" "\0"
  /*  9467 */ "PlacesEvent" "\0"
  /*  9479 */ "PlacesFavicon" "\0"
  /*  9493 */ "PlacesHistoryCleared" "\0"
  /*  9514 */ "PlacesObservers" "\0"
  /*  9530 */ "PlacesPurgeCaches" "\0"
  /*  9548 */ "PlacesRanking" "\0"
  /*  9562 */ "PlacesVisit" "\0"
  /*  9574 */ "PlacesVisitRemoved" "\0"
  /*  9593 */ "PlacesVisitTitle" "\0"
  /*  9610 */ "PlacesWeakCallbackWrapper" "\0"
  /*  9636 */ "Plugin" "\0"
  /*  9643 */ "PluginArray" "\0"
  /*  9655 */ "PluginCrashedEvent" "\0"
  /*  9674 */ "PointerEvent" "\0"
  /*  9687 */ "PopStateEvent" "\0"
  /*  9701 */ "PopupBlockedEvent" "\0"
  /*  9719 */ "PopupPositionedEvent" "\0"
  /*  9740 */ "PositionStateEvent" "\0"
  /*  9759 */ "PrecompiledScript" "\0"
  /*  9777 */ "PrioEncoder" "\0"
  /*  9789 */ "ProcessMessageManager" "\0"
  /*  9811 */ "ProcessingInstruction" "\0"
  /*  9833 */ "ProgressEvent" "\0"
  /*  9847 */ "PromiseDebugging" "\0"
  /*  9864 */ "PromiseNativeHandler" "\0"
  /*  9885 */ "PromiseRejectionEvent" "\0"
  /*  9907 */ "PublicKeyCredential" "\0"
  /*  9927 */ "PushEvent" "\0"
  /*  9937 */ "PushManager" "\0"
  /*  9949 */ "PushManagerImpl" "\0"
  /*  9965 */ "PushMessageData" "\0"
  /*  9981 */ "PushSubscription" "\0"
  /*  9998 */ "PushSubscriptionOptions" "\0"
  /* 10022 */ "RTCCertificate" "\0"
  /* 10037 */ "RTCDTMFSender" "\0"
  /* 10051 */ "RTCDTMFToneChangeEvent" "\0"
  /* 10074 */ "RTCDataChannel" "\0"
  /* 10089 */ "RTCDataChannelEvent" "\0"
  /* 10109 */ "RTCDtlsTransport" "\0"
  /* 10126 */ "RTCIceCandidate" "\0"
  /* 10142 */ "RTCIdentityProviderRegistrar" "\0"
  /* 10171 */ "RTCPeerConnection" "\0"
  /* 10189 */ "RTCPeerConnectionIceEvent" "\0"
  /* 10215 */ "RTCPeerConnectionStatic" "\0"
  /* 10239 */ "RTCRtpReceiver" "\0"
  /* 10254 */ "RTCRtpSender" "\0"
  /* 10267 */ "RTCRtpTransceiver" "\0"
  /* 10285 */ "RTCSessionDescription" "\0"
  /* 10307 */ "RTCStatsReport" "\0"
  /* 10322 */ "RTCTrackEvent" "\0"
  /* 10336 */ "RadioNodeList" "\0"
  /* 10350 */ "Range" "\0"
  /* 10356 */ "ReadableByteStreamController" "\0"
  /* 10385 */ "ReadableStream" "\0"
  /* 10400 */ "ReadableStreamBYOBReader" "\0"
  /* 10425 */ "ReadableStreamBYOBRequest" "\0"
  /* 10451 */ "ReadableStreamDefaultController" "\0"
  /* 10483 */ "ReadableStreamDefaultReader" "\0"
  /* 10511 */ "Report" "\0"
  /* 10518 */ "ReportBody" "\0"
  /* 10529 */ "ReportingObserver" "\0"
  /* 10547 */ "Request" "\0"
  /* 10555 */ "ResizeObserver" "\0"
  /* 10570 */ "ResizeObserverEntry" "\0"
  /* 10590 */ "ResizeObserverSize" "\0"
  /* 10609 */ "Response" "\0"
  /* 10618 */ "SVGAElement" "\0"
  /* 10630 */ "SVGAngle" "\0"
  /* 10639 */ "SVGAnimateElement" "\0"
  /* 10657 */ "SVGAnimateMotionElement" "\0"
  /* 10681 */ "SVGAnimateTransformElement" "\0"
  /* 10708 */ "SVGAnimatedAngle" "\0"
  /* 10725 */ "SVGAnimatedBoolean" "\0"
  /* 10744 */ "SVGAnimatedEnumeration" "\0"
  /* 10767 */ "SVGAnimatedInteger" "\0"
  /* 10786 */ "SVGAnimatedLength" "\0"
  /* 10804 */ "SVGAnimatedLengthList" "\0"
  /* 10826 */ "SVGAnimatedNumber" "\0"
  /* 10844 */ "SVGAnimatedNumberList" "\0"
  /* 10866 */ "SVGAnimatedPreserveAspectRatio" "\0"
  /* 10897 */ "SVGAnimatedRect" "\0"
  /* 10913 */ "SVGAnimatedString" "\0"
  /* 10931 */ "SVGAnimatedTransformList" "\0"
  /* 10956 */ "SVGAnimationElement" "\0"
  /* 10976 */ "SVGCircleElement" "\0"
  /* 10993 */ "SVGClipPathElement" "\0"
  /* 11012 */ "SVGComponentTransferFunctionElement" "\0"
  /* 11048 */ "SVGDefsElement" "\0"
  /* 11063 */ "SVGDescElement" "\0"
  /* 11078 */ "SVGElement" "\0"
  /* 11089 */ "SVGEllipseElement" "\0"
  /* 11107 */ "SVGFEBlendElement" "\0"
  /* 11125 */ "SVGFEColorMatrixElement" "\0"
  /* 11149 */ "SVGFEComponentTransferElement" "\0"
  /* 11179 */ "SVGFECompositeElement" "\0"
  /* 11201 */ "SVGFEConvolveMatrixElement" "\0"
  /* 11228 */ "SVGFEDiffuseLightingElement" "\0"
  /* 11256 */ "SVGFEDisplacementMapElement" "\0"
  /* 11284 */ "SVGFEDistantLightElement" "\0"
  /* 11309 */ "SVGFEDropShadowElement" "\0"
  /* 11332 */ "SVGFEFloodElement" "\0"
  /* 11350 */ "SVGFEFuncAElement" "\0"
  /* 11368 */ "SVGFEFuncBElement" "\0"
  /* 11386 */ "SVGFEFuncGElement" "\0"
  /* 11404 */ "SVGFEFuncRElement" "\0"
  /* 11422 */ "SVGFEGaussianBlurElement" "\0"
  /* 11447 */ "SVGFEImageElement" "\0"
  /* 11465 */ "SVGFEMergeElement" "\0"
  /* 11483 */ "SVGFEMergeNodeElement" "\0"
  /* 11505 */ "SVGFEMorphologyElement" "\0"
  /* 11528 */ "SVGFEOffsetElement" "\0"
  /* 11547 */ "SVGFEPointLightElement" "\0"
  /* 11570 */ "SVGFESpecularLightingElement" "\0"
  /* 11599 */ "SVGFESpotLightElement" "\0"
  /* 11621 */ "SVGFETileElement" "\0"
  /* 11638 */ "SVGFETurbulenceElement" "\0"
  /* 11661 */ "SVGFilterElement" "\0"
  /* 11678 */ "SVGForeignObjectElement" "\0"
  /* 11702 */ "SVGGElement" "\0"
  /* 11714 */ "SVGGeometryElement" "\0"
  /* 11733 */ "SVGGradientElement" "\0"
  /* 11752 */ "SVGGraphicsElement" "\0"
  /* 11771 */ "SVGImageElement" "\0"
  /* 11787 */ "SVGLength" "\0"
  /* 11797 */ "SVGLengthList" "\0"
  /* 11811 */ "SVGLineElement" "\0"
  /* 11826 */ "SVGLinearGradientElement" "\0"
  /* 11851 */ "SVGMPathElement" "\0"
  /* 11867 */ "SVGMarkerElement" "\0"
  /* 11884 */ "SVGMaskElement" "\0"
  /* 11899 */ "SVGMatrix" "\0"
  /* 11909 */ "SVGMetadataElement" "\0"
  /* 11928 */ "SVGNumber" "\0"
  /* 11938 */ "SVGNumberList" "\0"
  /* 11952 */ "SVGPathElement" "\0"
  /* 11967 */ "SVGPathSeg" "\0"
  /* 11978 */ "SVGPathSegArcAbs" "\0"
  /* 11995 */ "SVGPathSegArcRel" "\0"
  /* 12012 */ "SVGPathSegClosePath" "\0"
  /* 12032 */ "SVGPathSegCurvetoCubicAbs" "\0"
  /* 12058 */ "SVGPathSegCurvetoCubicRel" "\0"
  /* 12084 */ "SVGPathSegCurvetoCubicSmoothAbs" "\0"
  /* 12116 */ "SVGPathSegCurvetoCubicSmoothRel" "\0"
  /* 12148 */ "SVGPathSegCurvetoQuadraticAbs" "\0"
  /* 12178 */ "SVGPathSegCurvetoQuadraticRel" "\0"
  /* 12208 */ "SVGPathSegCurvetoQuadraticSmoothAbs" "\0"
  /* 12244 */ "SVGPathSegCurvetoQuadraticSmoothRel" "\0"
  /* 12280 */ "SVGPathSegLinetoAbs" "\0"
  /* 12300 */ "SVGPathSegLinetoHorizontalAbs" "\0"
  /* 12330 */ "SVGPathSegLinetoHorizontalRel" "\0"
  /* 12360 */ "SVGPathSegLinetoRel" "\0"
  /* 12380 */ "SVGPathSegLinetoVerticalAbs" "\0"
  /* 12408 */ "SVGPathSegLinetoVerticalRel" "\0"
  /* 12436 */ "SVGPathSegList" "\0"
  /* 12451 */ "SVGPathSegMovetoAbs" "\0"
  /* 12471 */ "SVGPathSegMovetoRel" "\0"
  /* 12491 */ "SVGPatternElement" "\0"
  /* 12509 */ "SVGPoint" "\0"
  /* 12518 */ "SVGPointList" "\0"
  /* 12531 */ "SVGPolygonElement" "\0"
  /* 12549 */ "SVGPolylineElement" "\0"
  /* 12568 */ "SVGPreserveAspectRatio" "\0"
  /* 12591 */ "SVGRadialGradientElement" "\0"
  /* 12616 */ "SVGRect" "\0"
  /* 12624 */ "SVGRectElement" "\0"
  /* 12639 */ "SVGSVGElement" "\0"
  /* 12653 */ "SVGScriptElement" "\0"
  /* 12670 */ "SVGSetElement" "\0"
  /* 12684 */ "SVGStopElement" "\0"
  /* 12699 */ "SVGStringList" "\0"
  /* 12713 */ "SVGStyleElement" "\0"
  /* 12729 */ "SVGSwitchElement" "\0"
  /* 12746 */ "SVGSymbolElement" "\0"
  /* 12763 */ "SVGTSpanElement" "\0"
  /* 12779 */ "SVGTextContentElement" "\0"
  /* 12801 */ "SVGTextElement" "\0"
  /* 12816 */ "SVGTextPathElement" "\0"
  /* 12835 */ "SVGTextPositioningElement" "\0"
  /* 12861 */ "SVGTitleElement" "\0"
  /* 12877 */ "SVGTransform" "\0"
  /* 12890 */ "SVGTransformList" "\0"
  /* 12907 */ "SVGUnitTypes" "\0"
  /* 12920 */ "SVGUseElement" "\0"
  /* 12934 */ "SVGViewElement" "\0"
  /* 12949 */ "Sanitizer" "\0"
  /* 12959 */ "Scheduler" "\0"
  /* 12969 */ "Screen" "\0"
  /* 12976 */ "ScreenLuminance" "\0"
  /* 12992 */ "ScreenOrientation" "\0"
  /* 13010 */ "ScriptProcessorNode" "\0"
  /* 13030 */ "ScrollAreaEvent" "\0"
  /* 13046 */ "ScrollViewChangeEvent" "\0"
  /* 13068 */ "SecurityPolicyViolationEvent" "\0"
  /* 13097 */ "Selection" "\0"
  /* 13107 */ "ServiceWorker" "\0"
  /* 13121 */ "ServiceWorkerContainer" "\0"
  /* 13144 */ "ServiceWorkerGlobalScope" "\0"
  /* 13169 */ "ServiceWorkerRegistration" "\0"
  /* 13195 */ "SessionStoreFormData" "\0"
  /* 13216 */ "SessionStoreScrollData" "\0"
  /* 13239 */ "SessionStoreUtils" "\0"
  /* 13257 */ "ShadowRealmGlobalScope" "\0"
  /* 13280 */ "ShadowRoot" "\0"
  /* 13291 */ "SharedWorker" "\0"
  /* 13304 */ "SharedWorkerGlobalScope" "\0"
  /* 13328 */ "SimpleGestureEvent" "\0"
  /* 13347 */ "SourceBuffer" "\0"
  /* 13360 */ "SourceBufferList" "\0"
  /* 13377 */ "SpeechGrammar" "\0"
  /* 13391 */ "SpeechGrammarList" "\0"
  /* 13409 */ "SpeechRecognition" "\0"
  /* 13427 */ "SpeechRecognitionAlternative" "\0"
  /* 13456 */ "SpeechRecognitionError" "\0"
  /* 13479 */ "SpeechRecognitionEvent" "\0"
  /* 13502 */ "SpeechRecognitionResult" "\0"
  /* 13526 */ "SpeechRecognitionResultList" "\0"
  /* 13554 */ "SpeechSynthesis" "\0"
  /* 13570 */ "SpeechSynthesisErrorEvent" "\0"
  /* 13596 */ "SpeechSynthesisEvent" "\0"
  /* 13617 */ "SpeechSynthesisUtterance" "\0"
  /* 13642 */ "SpeechSynthesisVoice" "\0"
  /* 13663 */ "StaticRange" "\0"
  /* 13675 */ "StereoPannerNode" "\0"
  /* 13692 */ "Storage" "\0"
  /* 13700 */ "StorageEvent" "\0"
  /* 13713 */ "StorageManager" "\0"
  /* 13728 */ "StreamFilter" "\0"
  /* 13741 */ "StreamFilterDataEvent" "\0"
  /* 13763 */ "StructuredCloneHolder" "\0"
  /* 13785 */ "StructuredCloneTester" "\0"
  /* 13807 */ "StyleSheet" "\0"
  /* 13818 */ "StyleSheetApplicableStateChangeEvent" "\0"
  /* 13855 */ "StyleSheetList" "\0"
  /* 13870 */ "SubmitEvent" "\0"
  /* 13882 */ "SubtleCrypto" "\0"
  /* 13895 */ "SyncMessageSender" "\0"
  /* 13913 */ "SyncReadFile" "\0"
  /* 13926 */ "TCPServerSocket" "\0"
  /* 13942 */ "TCPServerSocketEvent" "\0"
  /* 13963 */ "TCPSocket" "\0"
  /* 13973 */ "TCPSocketErrorEvent" "\0"
  /* 13993 */ "TCPSocketEvent" "\0"
  /* 14008 */ "TaskController" "\0"
  /* 14023 */ "TaskPriorityChangeEvent" "\0"
  /* 14047 */ "TaskSignal" "\0"
  /* 14058 */ "TelemetryStopwatch" "\0"
  /* 14077 */ "TestUtils" "\0"
  /* 14087 */ "TestingDeprecatedInterface" "\0"
  /* 14114 */ "Text" "\0"
  /* 14119 */ "TextClause" "\0"
  /* 14130 */ "TextDecoder" "\0"
  /* 14142 */ "TextDecoderStream" "\0"
  /* 14160 */ "TextEncoder" "\0"
  /* 14172 */ "TextEncoderStream" "\0"
  /* 14190 */ "TextMetrics" "\0"
  /* 14202 */ "TextTrack" "\0"
  /* 14212 */ "TextTrackCue" "\0"
  /* 14225 */ "TextTrackCueList" "\0"
  /* 14242 */ "TextTrackList" "\0"
  /* 14256 */ "TimeEvent" "\0"
  /* 14266 */ "TimeRanges" "\0"
  /* 14277 */ "Touch" "\0"
  /* 14283 */ "TouchEvent" "\0"
  /* 14294 */ "TouchList" "\0"
  /* 14304 */ "TrackEvent" "\0"
  /* 14315 */ "TransformStream" "\0"
  /* 14331 */ "TransformStreamDefaultController" "\0"
  /* 14364 */ "TransitionEvent" "\0"
  /* 14380 */ "TreeColumn" "\0"
  /* 14391 */ "TreeColumns" "\0"
  /* 14403 */ "TreeContentView" "\0"
  /* 14419 */ "TreeWalker" "\0"
  /* 14430 */ "U2F" "\0"
  /* 14434 */ "UDPMessageEvent" "\0"
  /* 14450 */ "UDPSocket" "\0"
  /* 14460 */ "UIEvent" "\0"
  /* 14468 */ "URL" "\0"
  /* 14472 */ "URLSearchParams" "\0"
  /* 14488 */ "URLSearchParams Iterator" "\0"
  /* 14513 */ "UniFFIPointer" "\0"
  /* 14527 */ "UniFFIScaffolding" "\0"
  /* 14545 */ "UserInteraction" "\0"
  /* 14561 */ "UserProximityEvent" "\0"
  /* 14580 */ "VRDisplay" "\0"
  /* 14590 */ "VRDisplayCapabilities" "\0"
  /* 14612 */ "VRDisplayEvent" "\0"
  /* 14627 */ "VREyeParameters" "\0"
  /* 14643 */ "VRFieldOfView" "\0"
  /* 14657 */ "VRFrameData" "\0"
  /* 14669 */ "VRMockController" "\0"
  /* 14686 */ "VRMockDisplay" "\0"
  /* 14700 */ "VRPose" "\0"
  /* 14707 */ "VRServiceTest" "\0"
  /* 14721 */ "VRStageParameters" "\0"
  /* 14739 */ "VTTCue" "\0"
  /* 14746 */ "VTTRegion" "\0"
  /* 14756 */ "ValidityState" "\0"
  /* 14770 */ "VideoColorSpace" "\0"
  /* 14786 */ "VideoFrame" "\0"
  /* 14797 */ "VideoPlaybackQuality" "\0"
  /* 14818 */ "VideoTrack" "\0"
  /* 14829 */ "VideoTrackList" "\0"
  /* 14844 */ "VisualViewport" "\0"
  /* 14859 */ "WEBGL_color_buffer_float" "\0"
  /* 14884 */ "WEBGL_compressed_texture_astc" "\0"
  /* 14914 */ "WEBGL_compressed_texture_etc" "\0"
  /* 14943 */ "WEBGL_compressed_texture_etc1" "\0"
  /* 14973 */ "WEBGL_compressed_texture_pvrtc" "\0"
  /* 15004 */ "WEBGL_compressed_texture_s3tc" "\0"
  /* 15034 */ "WEBGL_compressed_texture_s3tc_srgb" "\0"
  /* 15069 */ "WEBGL_debug_renderer_info" "\0"
  /* 15095 */ "WEBGL_debug_shaders" "\0"
  /* 15115 */ "WEBGL_depth_texture" "\0"
  /* 15135 */ "WEBGL_draw_buffers" "\0"
  /* 15154 */ "WEBGL_explicit_present" "\0"
  /* 15177 */ "WEBGL_lose_context" "\0"
  /* 15196 */ "WaveShaperNode" "\0"
  /* 15211 */ "WebExtensionContentScript" "\0"
  /* 15237 */ "WebExtensionPolicy" "\0"
  /* 15256 */ "WebGL2RenderingContext" "\0"
  /* 15279 */ "WebGLActiveInfo" "\0"
  /* 15295 */ "WebGLBuffer" "\0"
  /* 15307 */ "WebGLContextEvent" "\0"
  /* 15325 */ "WebGLFramebuffer" "\0"
  /* 15342 */ "WebGLProgram" "\0"
  /* 15355 */ "WebGLQuery" "\0"
  /* 15366 */ "WebGLRenderbuffer" "\0"
  /* 15384 */ "WebGLRenderingContext" "\0"
  /* 15406 */ "WebGLSampler" "\0"
  /* 15419 */ "WebGLShader" "\0"
  /* 15431 */ "WebGLShaderPrecisionFormat" "\0"
  /* 15458 */ "WebGLSync" "\0"
  /* 15468 */ "WebGLTexture" "\0"
  /* 15481 */ "WebGLTransformFeedback" "\0"
  /* 15504 */ "WebGLUniformLocation" "\0"
  /* 15525 */ "WebGLVertexArrayObject" "\0"
  /* 15548 */ "WebKitCSSMatrix" "\0"
  /* 15564 */ "WebSocket" "\0"
  /* 15574 */ "WebrtcGlobalInformation" "\0"
  /* 15598 */ "WheelEvent" "\0"
  /* 15609 */ "Window" "\0"
  /* 15616 */ "WindowClient" "\0"
  /* 15629 */ "WindowContext" "\0"
  /* 15643 */ "WindowGlobalChild" "\0"
  /* 15661 */ "WindowGlobalParent" "\0"
  /* 15680 */ "WindowRoot" "\0"
  /* 15691 */ "Worker" "\0"
  /* 15698 */ "WorkerDebuggerGlobalScope" "\0"
  /* 15724 */ "WorkerGlobalScope" "\0"
  /* 15742 */ "WorkerLocation" "\0"
  /* 15757 */ "WorkerNavigator" "\0"
  /* 15773 */ "WorkerTestUtils" "\0"
  /* 15789 */ "Worklet" "\0"
  /* 15797 */ "WorkletGlobalScope" "\0"
  /* 15816 */ "WritableStream" "\0"
  /* 15831 */ "WritableStreamDefaultController" "\0"
  /* 15863 */ "WritableStreamDefaultWriter" "\0"
  /* 15891 */ "XMLDocument" "\0"
  /* 15903 */ "XMLHttpRequest" "\0"
  /* 15918 */ "XMLHttpRequestEventTarget" "\0"
  /* 15944 */ "XMLHttpRequestUpload" "\0"
  /* 15965 */ "XMLSerializer" "\0"
  /* 15979 */ "XPathEvaluator" "\0"
  /* 15994 */ "XPathExpression" "\0"
  /* 16010 */ "XPathResult" "\0"
  /* 16022 */ "XRBoundedReferenceSpace" "\0"
  /* 16046 */ "XRFrame" "\0"
  /* 16054 */ "XRInputSource" "\0"
  /* 16068 */ "XRInputSourceArray" "\0"
  /* 16087 */ "XRInputSourceEvent" "\0"
  /* 16106 */ "XRInputSourcesChangeEvent" "\0"
  /* 16132 */ "XRPose" "\0"
  /* 16139 */ "XRReferenceSpace" "\0"
  /* 16156 */ "XRReferenceSpaceEvent" "\0"
  /* 16178 */ "XRRenderState" "\0"
  /* 16192 */ "XRRigidTransform" "\0"
  /* 16209 */ "XRSession" "\0"
  /* 16219 */ "XRSessionEvent" "\0"
  /* 16234 */ "XRSpace" "\0"
  /* 16242 */ "XRSystem" "\0"
  /* 16251 */ "XRView" "\0"
  /* 16258 */ "XRViewerPose" "\0"
  /* 16271 */ "XRViewport" "\0"
  /* 16282 */ "XRWebGLLayer" "\0"
  /* 16295 */ "XSLTProcessor" "\0"
  /* 16309 */ "XULCommandEvent" "\0"
  /* 16325 */ "XULElement" "\0"
  /* 16336 */ "XULFrameElement" "\0"
  /* 16352 */ "XULMenuElement" "\0"
  /* 16367 */ "XULPopupElement" "\0"
  /* 16383 */ "XULResizerElement" "\0"
  /* 16401 */ "XULTextElement" "\0"
  /* 16416 */ "XULTreeElement" "\0"
  /* 16431 */ "console" "\0"
  /* 16439 */ "mozRTCIceCandidate" "\0"
  /* 16458 */ "mozRTCPeerConnection" "\0"
  /* 16479 */ "mozRTCSessionDescription" "\0"
  /* 16504 */ "webkitSpeechGrammar" "\0"
  /* 16524 */ "webkitSpeechGrammarList" "\0"
  /* 16548 */ "webkitSpeechRecognition" "\0"
  /* 16572 */ "webkitURL"
};

}  // namespace binding_detail

// Making this enum bigger than a uint16_t has consequences on the size
// of some structs (eg. WebIDLNameTableEntry) and tables. We should try
// to avoid that.
static_assert(EnumTypeFitsWithin<BindingNamesOffset, uint16_t>::value,
              "Size increase");

} // namespace mozilla::dom

